# fastutils

Collection of simple utils.

## Install

```shell
pip install fastutils
```

## Tested With Python

- 2.7
- 3.3
- 3.4
- 3.5
- 3.6
- 3.7
- 3.8
- 3.9
- 3.10
- 3.11

## Installed utils

1. fastutils.aesutils
    1. AES_BLOCK_SIZE
    1. decrypt
    1. decrypt_and_base64decode
    1. decrypt_and_safeb64decode
    1. decrypt_and_unhexlify
    1. encrypt
    1. encrypt_and_base64encode
    1. encrypt_and_hexlify
    1. encrypt_and_safeb64encode
    1. get_aes_mode
    1. get_md5_key
    1. get_mysql_aes_key
    1. get_padding_remove_method
    1. get_raw_aes_key
    1. get_sha1prng_key
    1. padding_ansix923
    1. padding_iso10126
    1. padding_pkcs5
    1. remove_padding_ansix923
    1. remove_padding_iso10126
    1. remove_padding_pkcs5
1. fastutils.cacheutils
    1. ReqIdCache
    1. cache
    1. get_cached_value
    1. simple_cache
1. fastutils.cipherutils
    1. AesCipher
    1. AesCtrCipher
    1. AesGcmCipher
    1. Base64Encoder
    1. CipherBase
    1. DecryptFailed
    1. EncoderBase
    1. HexlifyEncoder
    1. IvCipher
    1. IvfCipher
    1. MappingCipher
    1. MysqlAesCipher
    1. RawDataEncoder
    1. RawKeyAesCipher
    1. RsaCipher
    1. S12Cipher
    1. S1Cipher
    1. S2Cipher
    1. SafeBase64Encoder
    1. Utf8Encoder
    1. aes_padding_ansix923
    1. aes_padding_iso10126
    1. aes_padding_pkcs5
    1. get_aes_mode
    1. md5_key
    1. mysql_aes_key
    1. sha1prng_key
1. fastutils.dictutils
    1. HttpHeadersDict
    1. Object
    1. attrgetorset
    1. attrset
    1. change
    1. changes
    1. deep_merge
    1. diff
    1. fix_object
    1. ignore_none_item
    1. prefix_key
    1. select
    1. to_object
    1. touch
    1. update
1. fastutils.fsutils
    1. TemporaryFile
    1. copy
    1. expand
    1. file_content_replace
    1. filecopy
    1. first_exists_file
    1. get_application_config_filepath
    1. get_application_config_paths
    1. get_safe_filename
    1. get_size_deviation
    1. get_size_display
    1. get_swap_filename
    1. get_temp_workspace
    1. get_unit_size
    1. info
    1. load_application_config
    1. mkdir
    1. move
    1. pathjoin
    1. readfile
    1. rename
    1. rm
    1. safe_write
    1. size_unit_names
    1. size_unit_upper_limit
    1. touch
    1. treecopy
    1. write
1. fastutils.funcutils
    1. BunchCallable
    1. ChainableProxy
    1. call_with_inject
    1. chain
    1. classproperty
    1. get_all_builtin_exceptions
    1. get_builtins_dict
    1. get_class_name
    1. get_default_values
    1. get_inject_params
    1. get_method_help
    1. get_method_signature
    1. inspect
    1. is_a_class
    1. isclass
    1. mcall_with_inject
    1. signature
    1. try_again_on_error
1. fastutils.hashutils
    1. Base64ResultEncoder
    1. Blake2BHexlifyPasswordHash
    1. Blake2BPbkdf2PasswordHash
    1. Blake2BPbkdf2PasswordHashColon
    1. Blake2BSimplePasswordHash
    1. Blake2BSimpleSaltPasswordHash
    1. Blake2SHexlifyPasswordHash
    1. Blake2SPbkdf2PasswordHash
    1. Blake2SPbkdf2PasswordHashColon
    1. Blake2SSimplePasswordHash
    1. Blake2SSimpleSaltPasswordHash
    1. DigestResultEncoder
    1. HexlifyPasswordHashBase
    1. HexlifyResultEncoder
    1. Md5HexlifyPasswordHash
    1. Md5Pbkdf2PasswordHash
    1. Md5Pbkdf2PasswordHashColon
    1. Md5SimplePasswordHash
    1. Md5SimpleSaltPasswordHash
    1. PasswordHashMethodBase
    1. PasswordHashMethodNotSupportError
    1. Pbkdf2PasswordHashBase
    1. ResultEncoderBase
    1. Sha1HexlifyPasswordHash
    1. Sha1Pbkdf2PasswordHash
    1. Sha1Pbkdf2PasswordHashColon
    1. Sha1SimplePasswordHash
    1. Sha1SimpleSaltPasswordHash
    1. Sha224HexlifyPasswordHash
    1. Sha224Pbkdf2PasswordHash
    1. Sha224Pbkdf2PasswordHashColon
    1. Sha224SimplePasswordHash
    1. Sha224SimpleSaltPasswordHash
    1. Sha256HexlifyPasswordHash
    1. Sha256Pbkdf2PasswordHash
    1. Sha256Pbkdf2PasswordHashColon
    1. Sha256SimplePasswordHash
    1. Sha256SimpleSaltPasswordHash
    1. Sha384HexlifyPasswordHash
    1. Sha384Pbkdf2PasswordHash
    1. Sha384Pbkdf2PasswordHashColon
    1. Sha384SimplePasswordHash
    1. Sha384SimpleSaltPasswordHash
    1. Sha3_224HexlifyPasswordHash
    1. Sha3_224Pbkdf2PasswordHash
    1. Sha3_224Pbkdf2PasswordHashColon
    1. Sha3_224SimplePasswordHash
    1. Sha3_224SimpleSaltPasswordHash
    1. Sha3_256HexlifyPasswordHash
    1. Sha3_256Pbkdf2PasswordHash
    1. Sha3_256Pbkdf2PasswordHashColon
    1. Sha3_256SimplePasswordHash
    1. Sha3_256SimpleSaltPasswordHash
    1. Sha3_384HexlifyPasswordHash
    1. Sha3_384Pbkdf2PasswordHash
    1. Sha3_384Pbkdf2PasswordHashColon
    1. Sha3_384SimplePasswordHash
    1. Sha3_384SimpleSaltPasswordHash
    1. Sha3_512HexlifyPasswordHash
    1. Sha3_512Pbkdf2PasswordHash
    1. Sha3_512Pbkdf2PasswordHashColon
    1. Sha3_512SimplePasswordHash
    1. Sha3_512SimpleSaltPasswordHash
    1. Sha512HexlifyPasswordHash
    1. Sha512Pbkdf2PasswordHash
    1. Sha512Pbkdf2PasswordHashColon
    1. Sha512SimplePasswordHash
    1. Sha512SimpleSaltPasswordHash
    1. ShaHexlifyPasswordHash
    1. ShaPbkdf2PasswordHash
    1. ShaPbkdf2PasswordHashColon
    1. ShaSimplePasswordHash
    1. ShaSimpleSaltPasswordHash
    1. SimplePasswordHashBase
    1. SimpleSaltPasswordHashBase
    1. Sm3HexlifyPasswordHash
    1. Sm3Pbkdf2PasswordHash
    1. Sm3Pbkdf2PasswordHashColon
    1. Sm3SimplePasswordHash
    1. Sm3SimpleSaltPasswordHash
    1. Xxh128HexlifyPasswordHash
    1. Xxh128Pbkdf2PasswordHash
    1. Xxh128Pbkdf2PasswordHashColon
    1. Xxh128SimplePasswordHash
    1. Xxh128SimpleSaltPasswordHash
    1. Xxh32HexlifyPasswordHash
    1. Xxh32Pbkdf2PasswordHash
    1. Xxh32Pbkdf2PasswordHashColon
    1. Xxh32SimplePasswordHash
    1. Xxh32SimpleSaltPasswordHash
    1. Xxh64HexlifyPasswordHash
    1. Xxh64Pbkdf2PasswordHash
    1. Xxh64Pbkdf2PasswordHashColon
    1. Xxh64SimplePasswordHash
    1. Xxh64SimpleSaltPasswordHash
    1. algorithms_available
    1. get_blake2b
    1. get_blake2b_base64
    1. get_blake2b_digest
    1. get_blake2b_hexdigest
    1. get_blake2s
    1. get_blake2s_base64
    1. get_blake2s_digest
    1. get_blake2s_hexdigest
    1. get_file_blake2b
    1. get_file_blake2b_base64
    1. get_file_blake2b_digest
    1. get_file_blake2b_hexdigest
    1. get_file_blake2s
    1. get_file_blake2s_base64
    1. get_file_blake2s_digest
    1. get_file_blake2s_hexdigest
    1. get_file_hash
    1. get_file_hash_base64
    1. get_file_hash_hexdigest
    1. get_file_hash_result
    1. get_file_md5
    1. get_file_md5_base64
    1. get_file_md5_digest
    1. get_file_md5_hexdigest
    1. get_file_sha
    1. get_file_sha1
    1. get_file_sha1_base64
    1. get_file_sha1_digest
    1. get_file_sha1_hexdigest
    1. get_file_sha224
    1. get_file_sha224_base64
    1. get_file_sha224_digest
    1. get_file_sha224_hexdigest
    1. get_file_sha256
    1. get_file_sha256_base64
    1. get_file_sha256_digest
    1. get_file_sha256_hexdigest
    1. get_file_sha384
    1. get_file_sha384_base64
    1. get_file_sha384_digest
    1. get_file_sha384_hexdigest
    1. get_file_sha3_224
    1. get_file_sha3_224_base64
    1. get_file_sha3_224_digest
    1. get_file_sha3_224_hexdigest
    1. get_file_sha3_256
    1. get_file_sha3_256_base64
    1. get_file_sha3_256_digest
    1. get_file_sha3_256_hexdigest
    1. get_file_sha3_384
    1. get_file_sha3_384_base64
    1. get_file_sha3_384_digest
    1. get_file_sha3_384_hexdigest
    1. get_file_sha3_512
    1. get_file_sha3_512_base64
    1. get_file_sha3_512_digest
    1. get_file_sha3_512_hexdigest
    1. get_file_sha512
    1. get_file_sha512_base64
    1. get_file_sha512_digest
    1. get_file_sha512_hexdigest
    1. get_file_sha_base64
    1. get_file_sha_digest
    1. get_file_sha_hexdigest
    1. get_file_sm3
    1. get_file_sm3_base64
    1. get_file_sm3_digest
    1. get_file_sm3_hexdigest
    1. get_file_xxh128
    1. get_file_xxh128_base64
    1. get_file_xxh128_digest
    1. get_file_xxh128_hexdigest
    1. get_file_xxh32
    1. get_file_xxh32_base64
    1. get_file_xxh32_digest
    1. get_file_xxh32_hexdigest
    1. get_file_xxh64
    1. get_file_xxh64_base64
    1. get_file_xxh64_digest
    1. get_file_xxh64_hexdigest
    1. get_hash
    1. get_hash_base64
    1. get_hash_hexdigest
    1. get_hash_result
    1. get_md5
    1. get_md5_base64
    1. get_md5_digest
    1. get_md5_hexdigest
    1. get_password_hash
    1. get_password_hash_methods
    1. get_pbkdf2_blake2b
    1. get_pbkdf2_blake2s
    1. get_pbkdf2_hmac
    1. get_pbkdf2_md5
    1. get_pbkdf2_sha
    1. get_pbkdf2_sha1
    1. get_pbkdf2_sha224
    1. get_pbkdf2_sha256
    1. get_pbkdf2_sha384
    1. get_pbkdf2_sha3_224
    1. get_pbkdf2_sha3_256
    1. get_pbkdf2_sha3_384
    1. get_pbkdf2_sha3_512
    1. get_pbkdf2_sha512
    1. get_pbkdf2_sm3
    1. get_pbkdf2_xxh128
    1. get_pbkdf2_xxh32
    1. get_pbkdf2_xxh64
    1. get_salted_hash_base64
    1. get_sha
    1. get_sha1
    1. get_sha1_base64
    1. get_sha1_digest
    1. get_sha1_hexdigest
    1. get_sha224
    1. get_sha224_base64
    1. get_sha224_digest
    1. get_sha224_hexdigest
    1. get_sha256
    1. get_sha256_base64
    1. get_sha256_digest
    1. get_sha256_hexdigest
    1. get_sha384
    1. get_sha384_base64
    1. get_sha384_digest
    1. get_sha384_hexdigest
    1. get_sha3_224
    1. get_sha3_224_base64
    1. get_sha3_224_digest
    1. get_sha3_224_hexdigest
    1. get_sha3_256
    1. get_sha3_256_base64
    1. get_sha3_256_digest
    1. get_sha3_256_hexdigest
    1. get_sha3_384
    1. get_sha3_384_base64
    1. get_sha3_384_digest
    1. get_sha3_384_hexdigest
    1. get_sha3_512
    1. get_sha3_512_base64
    1. get_sha3_512_digest
    1. get_sha3_512_hexdigest
    1. get_sha512
    1. get_sha512_base64
    1. get_sha512_digest
    1. get_sha512_hexdigest
    1. get_sha_base64
    1. get_sha_digest
    1. get_sha_hexdigest
    1. get_sm3
    1. get_sm3_base64
    1. get_sm3_digest
    1. get_sm3_hexdigest
    1. get_xxh128
    1. get_xxh128_base64
    1. get_xxh128_digest
    1. get_xxh128_hexdigest
    1. get_xxh32
    1. get_xxh32_base64
    1. get_xxh32_digest
    1. get_xxh32_hexdigest
    1. get_xxh64
    1. get_xxh64_base64
    1. get_xxh64_digest
    1. get_xxh64_hexdigest
    1. is_the_same_hash_method
    1. method_load
    1. new
    1. pbkdf2_hmac
    1. register_hexlify_password_hash
    1. register_password_hash_method
    1. register_pbkdf2_password_hash
    1. register_simple_password_hash
    1. register_simple_salt_password_hash
    1. setup_hash_method_loader
    1. validate_password_hash
    1. validate_pbkdf2_blake2b
    1. validate_pbkdf2_blake2s
    1. validate_pbkdf2_hmac
    1. validate_pbkdf2_md5
    1. validate_pbkdf2_sha
    1. validate_pbkdf2_sha1
    1. validate_pbkdf2_sha224
    1. validate_pbkdf2_sha256
    1. validate_pbkdf2_sha384
    1. validate_pbkdf2_sha3_224
    1. validate_pbkdf2_sha3_256
    1. validate_pbkdf2_sha3_384
    1. validate_pbkdf2_sha3_512
    1. validate_pbkdf2_sha512
    1. validate_pbkdf2_sm3
    1. validate_pbkdf2_xxh128
    1. validate_pbkdf2_xxh32
    1. validate_pbkdf2_xxh64
1. fastutils.httputils
    1. download
    1. get_sitename
    1. get_url_filename
    1. get_url_save_path
    1. get_urlinfo
    1. urlparse
1. fastutils.imageutils
    1. get_base64image
    1. get_image_bytes
    1. parse_base64image
    1. resize
    1. resize_to_fixed_height
    1. resize_to_fixed_width
1. fastutils.jsonutils
    1. SimpleJsonEncoder
    1. make_simple_json_encoder
    1. register_global_encoder
    1. simple_json_dumps
1. fastutils.listutils
    1. append_new
    1. chunk
    1. clean_none
    1. compare
    1. compare_execute
    1. first
    1. group
    1. ignore_none_element
    1. int_list_to_bytes
    1. is_ordered
    1. list2dict
    1. pad
    1. replace
    1. topological_sort
    1. topological_test
    1. unique
1. fastutils.logutils
    1. get_console_handler
    1. get_file_handler
    1. get_simple_config
    1. setup
1. fastutils.msgpackutils
    1. EmptyMsgData
    1. Msg
    1. MsgDecryptFailed
    1. WrongMsgType
    1. dumps
    1. loads
1. fastutils.nameutils
    1. get_last_names
    1. get_random_name
    1. get_suggest_first_names
    1. guess_lastname
    1. guess_surname
1. fastutils.numericutils
    1. _infinity
    1. binary_decompose
    1. bytes2ints
    1. decimal_change_base
    1. float_split
    1. from_bytes
    1. get_float_part
    1. infinity
    1. int2bytes
    1. ints2bytes
    1. is_infinity
    1. ninfinity
    1. pinfinity
1. fastutils.pinyinutils
    1. to_pinyin
1. fastutils.randomutils
    1. Lcg31Random
    1. Random
    1. UuidGenerator
    1. choices
    1. get_password_seed32
    1. uuid1
    1. uuid3
    1. uuid4
    1. uuid5
1. fastutils.rsautils
    1. decrypt
    1. encrypt
    1. export_key
    1. get_hash_method
    1. load_private_key
    1. load_public_key
    1. load_public_key_from_private_key
    1. newkeys
    1. sign
    1. verify
1. fastutils.strutils
    1. BAI
    1. BASE64_CHARS
    1. HEXLIFY_CHARS
    1. QIAN
    1. SHI
    1. StrUtils
    1. URLSAFEB64_CHARS
    1. WAN
    1. YI
    1. binarify
    1. bytes2ints
    1. camel
    1. captital_number
    1. char_force_to_int
    1. chunk
    1. clean
    1. combinations
    1. combinations2
    1. decodable
    1. default_cn_digits
    1. default_cn_float_places
    1. default_cn_negative
    1. default_cn_places
    1. default_cn_yuan
    1. default_encoding
    1. default_encodings
    1. default_quotes
    1. default_random_string_choices
    1. do_clean
    1. encodable
    1. force_float
    1. force_int
    1. force_numberic
    1. force_type_to
    1. format_with_mapping
    1. get_all_substrings
    1. get_base64image
    1. get_image_bytes
    1. html_element_css_append
    1. int2bytes
    1. ints2bytes
    1. is_base64_decodable
    1. is_chinese_character
    1. is_hex_digits
    1. is_str_composed_by_the_choices
    1. is_unhexlifiable
    1. is_urlsafeb64_decodable
    1. is_uuid
    1. join_lines
    1. no_mapping
    1. none_to_empty_string
    1. parse_base64image
    1. random_string
    1. remove_prefix
    1. remove_suffix
    1. reverse
    1. simple_cn_yuan
    1. simplesplit
    1. smart_get_binary_data
    1. split
    1. split2
    1. str_composed_by
    1. stringlist_append
    1. strip_string
    1. substrings
    1. text_display_length
    1. text_display_shorten
    1. unbinarify
    1. unquote
    1. wholestrip
1. fastutils.sysutils
    1. default_timeout_kill
    1. execute_script
    1. get_current_thread_id
    1. get_daemon_application_pid
    1. get_node_ip
    1. get_random_script_name
    1. get_worker_id
    1. get_worker_info
    1. psutil_timeout_kill
1. fastutils.threadutils
    1. ConcurrentLimitJobQueue
    1. Counter
    1. Future
    1. JobExecuteTimeout
    1. JobQueue
    1. JobResultNotSet
    1. LoopIdle
    1. Service
    1. ServiceStop
    1. ServiceTerminate
    1. SimpleConsumer
    1. SimpleProducer
    1. SimpleProducerConsumerServer
    1. SimpleServer
    1. StartOnTerminatedService
1. fastutils.treeutils
    1. SimpleRouterTree
    1. build_tree
    1. print_tree
    1. print_tree_callback
    1. tree_walk
1. fastutils.typingutils
    1. Number
    1. STRING_ENCODINGS
    1. register_global_caster
    1. smart_cast

## Help

See pydoc for help.

```
python3 -m pydoc -b # start pydoc
```

## Usage Examples

### fastutils.strutils.chunk

```
from fastutils import strutils

In [33]: strutils.chunk('hello', 3)
Out[33]: ['hel', 'lo']

In [34]: strutils.chunk('hello', 6)
Out[34]: ['hello']

In [35]: strutils.chunk('hello', 5)
Out[35]: ['hello']
```

### fastutils.strutils.get_all_substrings

```
from fastutils import strutils

In [4]: strutils.get_all_substrings('a')
Out[4]: {'a'}

In [5]: strutils.get_all_substrings('ab')
Out[5]: {'a', 'ab', 'b'}

In [6]: strutils.get_all_substrings('abc')
Out[6]: {'a', 'ab', 'abc', 'b', 'bc', 'c'}

In [7]: strutils.get_all_substrings('abcd')
Out[7]: {'a', 'ab', 'abc', 'abcd', 'b', 'bc', 'bcd', 'c', 'cd', 'd'}
```

### fastutils.listutils.list2dict

```
In [1]: from fastutils import listutils

In [2]: listutils.list2dict([1,2,3], ['a', 'b'])
Out[2]: {'a': 1, 'b': 2}

In [3]: listutils.list2dict([1,2,3], ['a', 'b', 'c'])
Out[3]: {'a': 1, 'b': 2, 'c': 3}

In [4]: listutils.list2dict([1,2,3], ['a', 'b', 'c', 'd'])
Out[4]: {'a': 1, 'b': 2, 'c': 3, 'd': None}
```

### fastutils.listutils.compare_execute

*Example 1*

```
from fastutils import listutils

old_list = [1,2,3]
new_list = [2,3,4]

created, deleted, changed = listutils.compare_execute(
      old_data=old_list,
      new_data=new_list,
      create_callback=lambda key, data: data,
      delete_callback=lambda key, instance: instance,
      change_callback=lambda key, instance, data: instance,
      old_key=lambda x: x
)
assert created == [4]
assert deleted == [1]
assert changed == [2, 3]
```

*Example 2*

```
from fastutils import listutils

old_list = [1,2,3]
new_list = [3,4,5]

def do_create(key, data):
   if data > 4:
         return data
   else:
         return None

def do_delete(key, instance):
   if instance > 1:
         return instance
   else:
         return None

def do_change(key, instance, data):
   return None

created, deleted, changed = listutils.compare_execute(
   old_data=old_list,
   new_data=new_list,
   create_callback=do_create,
   delete_callback=do_delete,
   change_callback=do_change,
   old_key=lambda x: x
)
assert created == [5]
assert deleted == [2]
assert changed == []
```


## Releases

### v0.43.1

- Unit test problems fix.
- Add cipherutils.AesCtrCipher.
- Add cipherutils.AesGcmCipher.

### v0.43.0

- Doc Update.
- Add python_requires in setup. 
- Fix sysutils.get_worker_info problem in docker env.

### v0.42.14

- Add fastutils.listutils.compare_execute.
- Add fastutils.dictutils.Object.fix to fix the Object instance if you added a dict thing to the Objects' list/dict item.

### v0.42.13

- Add fastutils.strutils.get_all_substrings.
- Add fastutils.listutils.list2dict.

### v0.42.11

- Fix fastutils.cipherutils.CipherBase incompatibility problem.

### v0.43.9

- doc update.

### v0.42.8

- Fix threadutils.Counter incr/decr result value duplicate problem.

### v0.42.7

- Fix logutils formatter missing problem.

### v0.42.6

- Add filelike-methods for fsutils.TemporaryFile.

### v0.42.5

- Add TemporaryFile.open and TemporaryFile.close methods.

### v0.42.4

- Change rsautils.encrypt default envelope method to PKCS1_OAEP, and rsautils.decrypt support both PKCS1_OAEP and PKCS1_v1_5 methods.
- Add rsautils.sign and resautils.verify methods.

### v0.42.3

- Add console_handler_class and file_handler_class parameters for function logutils.get_simple_config.
- Add simple and simple_json formatter in logutils.get_simple_config.

### v0.42.2

- Add sysutils.get_worker_info.
- Fix logutils' implicit imports problem.
- Fix funcutils.classproperty.

### v0.42.1

- Fix logutils problem.

### v0.42.0

- Add msgpackutils.
- Fix problem in nameutils.

### v0.41.1

- Fix numericutils.get_float_part problem.

### v0.41.0

- cipherutils changes.
- Fix license_files missing problem.

### v0.40.2

- Add cipherutils.raw_aes_key.
- Add cipherutils.get_aes_mode.

### v0.40.0

- Add listutils.chunk.
- New threadutils.
- Fix dictutils.Object.

### v0.39.8

- fsutils.TemporaryFile add auto delete.
- dictutils.changes can return changed keys.
- dictutils.change can control do update or not.
- dictutils.change add ignore_empty_value support.

### v0.39.7

- Fix strutils.force_byte, strutils.force_text.

### v0.39.6

- Fix encode_datetime problem.

### v0.39.5

- Add field name while failed to do typing cast.

### v0.39.4

- Add more default jsonutils encoders.

### v0.39.1

- Fix logutils.setup default config for windows.

### v0.39.0

- Change logutils.setup parameter name.
- Fix bizerror.BizError encoding problem in jsonutils.

### v0.38.2

- Add timeutils.TimeService.

### v0.37.11

- Fix fsutils.write.

### v0.37.10

- fsutils.readfile add default params. The default value will be returned if the target file is not exists.
- Add dictutils.diff function.
- Force folder create in fsutils.write.
- Make sure log folder exists in logutils.setup.
- Add sysutils.execute_script.

### v0.37.3

- Add PyYAML deps in requirements.txt.

### v0.37.2

- SimpleProducerConsumerServerBase.on_consume_error function add new parameter: task.
- Fix threadutils problems. Many changes are made.

### v0.37.0

- Add fsutils.load_application_config.

### v0.36.2

- Add fsutils.TemporaryFile
- Add threadutils.SimpleProducerConsumerServer and fix problems in ServiceCore.

### v0.35.0

- strutils.is_uuid add allow_bad_characters parameter, default to False. For some old bad application using '815f5ecb-eg07-43af-8de2-87d3898093b5' as UUID.
- Add nameutils.guess_surname.
- Add fsutils.get_size_deviation, fsutils.get_unit_size and fsutils.get_size_display.

### v0.34.0

- Add sysutils.get_daemon_application_pid.
- Add httputils.

### v0.33.0

- Add fsutils.info
- Add strutils.encodable and strutils.decodable

### v0.32.0

- Add funcutils.try_again_on_error.

### v0.31.0

- Add fsutils.expands.
- Add fsutils.get_application_config_filepath.

### v0.30.1

- Add cipherutils result_encoders' typing tips.

### v0.30.0

- Add strutils.stringlist_append.
- Add strutils.html_element_css_append.
- Add strutils.split2.
- Add strutils.remove_prefix.
- Add strutils.remove_suffix.
- Change strutils.split("", [","]) returns [] instead of [""].
- Add cipherutils.MysqlAesCipher.
- Add listutils.topological_sort.
- Add nameutils.

### v0.29.0

- Use pypinyin module instead of dragonmapper.
   - Replace the result lve to lue.

### v0.28.2

- Fix dictutils.update, so that it can works on anything.

### v0.28.1

- Add default parameter to fsutils.first_exists_file.

### v0.28.0

- Add fsutils.first_exists_file.
- Add fsutils.expand.
- Add listutils.first.

### v0.27.0

- Add lower_first parameter for strutils.camel.
- Add dictutils.prefix_key.
- Add sysutils.get_worker_id.

### v0.26.0

- Add treeutils.build_tree from list.
- Add treeutils.walk_tree.
- Add treeutils.print_tree.
- Add fsutils.touch.

### v0.25.0

- Add strutils.is_uuid.
- Add typingutils.cast_uuid.

### v0.24.2

- fsutils.file_content_replace add ignore_errors parameter.

### v0.24.1

- typingutils.cast_xxx treat empty string as None.
- randomutils.UuidGenerator.next add parameter n, so that it can generate n uuids. If n==1, returns a UUID instance, and if n>1, returns a list of UUIDs.

### v0.24.0

- Add strutils.unquote.

### v0.23.0

- Add funcutils.get_default_values.
- Add funcutils.chain.

### v0.22.0

- Add none-dict support in dictutils.change and dictutils.changes.
- Add strutils.format_with_mapping.

### v0.21.0

- Add listutils.compare(old_set, new_set).
- Add dictutils.change(object_instance, data_dict, object_key, dict_key=None) -> bool.
- Add dictutils.changes(object_instance, data_dict, keys) -> bool:
- Change listutils.replace, turn the default value of parameter inplace from True to False.
- Fix Object instance problems.

### v0.20.0

- Add strutils.clean and change strutils.camel.
- Add dictutils.to_object.
- Add pinyinutils.


### v0.19.0

- Add fsutils.filecopy and fsutils.treecopy. Tips: fsutils.copy combines the function of filecopy and treecopy, if the src is a file then use filecopy, and if the src is a folder then use treecopy.
- Fix problem in fsutils.copy.

### v0.18.0

- Add strutils.camel.

### v0.17.0

- Add fsutils.file_content_replace.
- Add fsutils.move.
- Change fsutils.rename's behavior.
- Change fsutils.copy's behavior.

### v0.16.0

- Add fsutils.

### v0.15.2

- Add hostname, seed1, seed4 in domain_template of randomutils.UuidGenerator.

### v0.15.1

- Add incr-lock for counter incr in randomutils.UuidGenerator.

### v0.15.0

- Add randomutils.UuidGenerator.

### v0.14.0

- Add strutils.substrings.
- Add strutils.combinations.
- Add cipherutils.Utf8Encoder.
- Add cipherutils.S1Cipher.
- Add cipherutils.S2Cipher.
- Add funcutils.classproperty
- WARN: Change a cipherutils.CipherBase's parameter name from encoder to result_encoder.

### v0.13.4

- Use new algorithm to improve randomutils.shuffle's performance.

### v0.13.3

- Add randomutils.shuffle.
- Change randomutils.randint parameters from (max, min=0) to (a, b=None).

### v0.13.2

- Add listutils.group.
- Add rsautils.export_key. And rsautils use Crypto.PublicKey.RSA for the base engine.

### v0.13.1

- Add strutils.force_float and strutils.force_numeric.
- Add typingutils.cast_numeric support.

### v0.13.0

- IvfCihper accept integer value when float_digits=0.
- Fix IvfCihper deviation problem which is caused by wrong module used in decrypt.
- IvfCihper use new algorithm in computing module and max_value, **so that result encrypted by version v0.12.0 can not decrypted by version v0.13.0**.

### v0.12.0

- Add IvfCihper for float number encrypt and decrypt. The output of IvfCipher.encrypt is string.

### v0.11.1

- Use class instead of raw api for s12 and iv ciphers. It's can avoid many times in generating seeds.

### v0.11.0

- Add cipherutils.
- Add strutils.binarify and strutils.unbinarify.
- Add randomutils.Random.
- Change aesutils functions' return type. Note: use cipherutils instead.

### v0.10.1

- Add bizerror dependency.

### v0.10.0

- Add strutils.is_chinese_character to test if the character is a chinese character.
- Add cacheutils.get_cached_value to get or set cached value.

### v0.9.0

- Add listutils.append_new to append new value and only new value to the list.

### v0.8.0

- Add strutils.smart_get_binary_data.
- Add rsautils.

### v0.7.0

- Add hashutils.get_file_hash.
- Add extra install requires for python 2.x.
- Add imageutils.parse_base64image and imageutils.get_image_bytes.
- Fix jsonutils.make_simple_json_encoder ignore bases problem.

### v0.6.0

- Add imageutils, add imageutils.get_base64image to make base64 image that can be rendered by web browser.
- Add imageutils.resize to scale image size.
- Add Image-Object-Encode support in jsonutils.
- Add threadutils, add threadutils.Service to simplify long-run-service programming.
- Raise bizerror.MissingParameter error in funcutils.get_inject_params while missing required parameter.

### v0.5.4

- Fix hashutils.get_hash_hexdigest and hashutils.get_hash_base64 problem.

### v0.5.3

- Using typingutils.smart_cast in funcutils.get_inject_params.

### v0.5.2

- Add unit test cases for typingutils.
- Fix cast_list, do strip for every element in comma-separated-list.
- Fix base64 import missing in typingutils.

### v0.5.1

- Add typingutils.cast_str.

### v0.5.0

- Set library property in get_encoder in jsonutils.
- Add typingutils.

### v0.4.0

- Add jsonutils, provides simple json encoder register system.

### v0.3.2

- Fix problems for python 2.7.
- Fix name error of funcutils.

### v0.3.1

- Fix problem casued by str.isascii() which is new from python 3.7.

### v0.3.0

- Add listutils.unique to remove duplicated elements from the list.
- Add listutils.replace to replace element value in thelist with new_value in collection of map.

### v0.2.0

- Add functuils.get_inject_params to smartly choose parameters from candidates by determine with the function's signature.
- Add functuils.call_with_inject to smartly call the function by smartly choose parameters.

### v0.1.1

- Add strutils.wholestrip function, use to remove all white spaces in text.
- Fix strutils.is_urlsafeb64_decodable, strutils.is_base64_decodable and strutils.is_unhexlifiable functions, that have problem to test text contains whitespaces.

### v0.1.0

- Add simple utils about operations of aes, dict, hash, list and str.
